package dev.shadowsoffire.apotheosis.util;

import net.minecraftforge.network.NetworkDirection;
import java.util.Optional;
import dev.shadowsoffire.placebo.network.MessageHelper;
import net.minecraft.core.particles.ParticleOptions;
import net.minecraft.client.Minecraft;
import net.minecraftforge.network.NetworkEvent;
import java.util.function.Supplier;
import net.minecraftforge.registries.ForgeRegistries;
import net.minecraftforge.registries.ForgeRegistry;
import net.minecraft.network.FriendlyByteBuf;
import dev.shadowsoffire.placebo.network.MessageProvider;
import net.minecraft.core.particles.ParticleType;

public class ParticleMessage
{
    ParticleType<?> type;
    double x;
    double y;
    double z;
    double velX;
    double velY;
    double velZ;
    int count;
    
    public ParticleMessage() {
    }
    
    public ParticleMessage(final ParticleType<?> type, final double x, final double y, final double z, final double velX, final double velY, final double velZ, final int count) {
        this.type = type;
        this.x = x;
        this.y = y;
        this.z = z;
        this.velX = velX;
        this.velY = velY;
        this.velZ = velZ;
        this.count = count;
    }
    
    public static class Provider implements MessageProvider<ParticleMessage>
    {
        public Class<ParticleMessage> getMsgClass() {
            return ParticleMessage.class;
        }
        
        public ParticleMessage read(final FriendlyByteBuf buf) {
            final ParticleType<?> type = (ParticleType<?>)((ForgeRegistry)ForgeRegistries.PARTICLE_TYPES).getValue(buf.readInt());
            final double x = buf.readDouble();
            final double y = buf.readDouble();
            final double z = buf.readDouble();
            final double velX = buf.readDouble();
            final double velY = buf.readDouble();
            final double velZ = buf.readDouble();
            final int count = buf.readInt();
            return new ParticleMessage(type, x, y, z, velX, velY, velZ, count);
        }
        
        public void write(final ParticleMessage msg, final FriendlyByteBuf buf) {
            buf.writeInt(((ForgeRegistry)ForgeRegistries.PARTICLE_TYPES).getID((Object)msg.type));
            buf.writeDouble(msg.x).writeDouble(msg.y).writeDouble(msg.z);
            buf.writeDouble(msg.velX).writeDouble(msg.velY).writeDouble(msg.velZ);
            buf.writeInt(msg.count);
        }
        
        public void handle(final ParticleMessage msg, final Supplier<NetworkEvent.Context> ctx) {
            MessageHelper.handlePacket(() -> {
                for (int i = 0; i < msg.count; ++i) {
                    Minecraft.m_91087_().f_91073_.m_7106_((ParticleOptions)msg.type, msg.x, msg.y, msg.z, msg.velX, msg.velY, msg.velZ);
                }
            }, (Supplier)ctx);
        }
        
        public Optional<NetworkDirection> getNetworkDirection() {
            return Optional.of(NetworkDirection.PLAY_TO_CLIENT);
        }
    }
}
